Subject: [lmap] protocol selection: lmap yang data model / restconf protocol

From: Juergen Schoenwaelder <[email-masked]>
Date: Thu, 19 Mar 2015 15:45:56 +0100

Hi,

here is our attempt to match the YANG data model / RESTCONF
protocol proposal against the protocol selection criteria in
draft-starkcarey-lmap-protocol-criteria-01:

I am not sure whether there are any competitors in the race. But if
so, it would be nice if they could also post their match against the
criteria also before the meeting so that we can all come prepared.

/js

  CP-MUST-1 yes (RFC6241 RFC6242, RFC5539), draft-ietf-netconf-restconf-04
  CP-MUST-2 yes draft-ietf-netconf-call-home-04
  CP-MUST-3 yes SSH / TLS (NETCONF), TLS (RESTCONF)
  CP-MUST-4 yes YANG RFC 6020 data models have a version model

  CP-DIFF-1 1
  CP-DIFF-2 1
  CP-DIFF-3 yes
  CP-DIFF-4 yes (NETCONF|RESTCONF) call home
  CP-DIFF-5 (underspecified - it is JSON or XML over HTTP/TLS)
  CP-DIFF-6 (underspecified - it is JSON or XML over HTTP/TLS)
  CP-DIFF-7 HTTP and JSON/XML are pretty much everywhere
  CP-DIFF-8 YANG tools are out there and the rest will develop,
            HTTP and TLS are pretty well understood
  CP-DIFF-9 yes
  CP-DIFF-10 many tools out there to create REST code, YANG tools available
  CP-DIFF-11 yes, YANG RFC 6020 data models have a version model
  CP-DIFF-12 additional YANG modules can augment the standard data model
  CP-DIFF-13 JSON and XML, CBOR in the making
  
  RP-MUST-1 yes draft-ietf-netconf-call-home-04
  RP-MUST-2 SSH / TLS (NETCONF), TLS (RESTCONF)
  RP-MUST-3 YANG RFC 6020 data models have a version model

  RP-DIFF-1 TCP
  RP-DIFF-2 yes
  RP-DIFF-3 (underspecified - it is HTTP over TLS)
  RP-DIFF-4 yes
  RP-DIFF-5 yes
  RP-DIFF-6 yes (as part of HTTP encoding negotiations)
  RP-DIFF-7 (underspecified - it is JSON or XML over HTTP/TLS)
  RP-DIFF-8 HTTP and JSON/XML are pretty much everywhere
  RP-DIFF-9 many tools out there to create REST code, YANG tools available
  RP-DIFF-10 yes
  RP-DIFF-11 many tools out there to create REST code, YANG tools available
  RP-DIFF-12 JSON and XML, CBOR in the making
  
/js

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
Fax:   +49 421 200 3103         <http://www.jacobs-university.de/>

---

From: "Romascanu, Dan (Dan)" <[email-masked]>
Date: Thu, 19 Mar 2015 14:54:16 +0000

Thanks, Juergen.

We also have https://datatracker.ietf.org/doc/draft-liu-lmap-rest/. 

The other proposal I know about is https://datatracker.ietf.org/doc/draft-bagnulo-lmap-http/ which you are also a co-author. Does the YANG / RESTCONF proposal replace that? 

Anyway - this is the expected input and as you say - all other proposals are welcome to post their match against the criteria prior to the meeting next week. 

Regards,

Dan

> -----Original Message-----
> From: lmap [mailto:[email-masked]] On Behalf Of Juergen
> Schoenwaelder
> Sent: Thursday, March 19, 2015 4:46 PM
> To: [email-masked]
> Subject: [lmap] protocol selection: lmap yang data model / restconf protocol
> 
> Hi,
> 
> here is our attempt to match the YANG data model / RESTCONF protocol
> proposal against the protocol selection criteria in
> I am not sure whether there are any competitors in the race. But if so, it
> would be nice if they could also post their match against the criteria also
> before the meeting so that we can all come prepared.
> 
> /js
> 
> Fax:   +49 421 200 3103
> <https://urldefense.proofpoint.com/v2/url?u=http-3A__www.jacobs-
> 2Duniversity.de_&d=AwICAg&c=BFpWQw8bsuKpl1SgiZH64Q&r=I4dzGxR31O
> cNXCJfQzvlsiLQfucBXRucPvdrphpBsFA&m=XptJM1yRM_8oYj0Rau2Ya4IZWyP
> pcunI1qkF2d3xHq0&s=tP_oxXnMR5JkmjB4mdcj6ShixdAHaxkNH2OFdu1f1yU
> &e= >
> 
> _______________________________________________
> lmap mailing list
> [email-masked]
> https://urldefense.proofpoint.com/v2/url?u=https-
> 3A__www.ietf.org_mailman_listinfo_lmap&d=AwICAg&c=BFpWQw8bsuKpl
> 1SgiZH64Q&r=I4dzGxR31OcNXCJfQzvlsiLQfucBXRucPvdrphpBsFA&m=XptJM1
> yRM_8oYj0Rau2Ya4IZWyPpcunI1qkF2d3xHq0&s=PM4DWavORX2n2AsL4Fe5X
> u5atfs2vR-E3CX1YUwkE7Q&e=

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Thu, 19 Mar 2015 16:02:06 +0100

> The other proposal I know about is https://datatracker.ietf.org/doc/draft-bagnulo-lmap-http/ which you are also a co-author. Does the YANG / RESTCONF proposal replace that? 

I can't speak for the other co-authors, but since RESTCONF and
RESTCONF/NETCONF call home has significantly matured since the -00
version of this ID was written (July 2013), I think YANG/RESTCONF is a
viable option, although it swaps the client/server roles compared to
what was originally envisioned.

/js